magaz/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from django.conf import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('users.urls', namespace='users')),
    path('shop/', include('shop.urls', namespace='shop')),
    path('api/', include('shop.api.urls', namespace='api'))
]

if settings.DEBUG:
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

shop/api/urls.py
from django.urls import path


from .api_views import CategoryListAPIView, SmartphoneListAPIView, SmartphoneDetailAPIView, CustomersListAPIView


app_name = 'api'

urlpatterns = [
    path('categories/', CategoryListAPIView.as_view(), name='categories'),
    path('smartphones/', SmartphoneListAPIView.as_view(), name='smartphones'),
    path('smartphones/<str:id>/', SmartphoneDetailAPIView.as_view(), name='smartphone_detail'),
    path('customers/', CustomersListAPIView.as_view(), name='customers_list')
]

shop/urls.py
from django.urls import path
from .views import (
    BaseView,
    ProductDetailView,
    CategoryDetailView,
    CartView,
    AddToCartView,
    DeleteFromCartView,
    ChangeQTYView,
    CheckoutView,
    MakeOrderView,
)

app_name = 'shop'

urlpatterns = [
    path('', BaseView.as_view(), name='shop_main'),
    path('products/<str:ct_model>/<str:slug>', ProductDetailView.as_view(), name='product_detail'),
    path('category/<str:slug>', CategoryDetailView.as_view(), name='category_detail'),
    path('cart/', CartView.as_view(), name='cart'),
    path('add-to-cart/<str:ct_model>/<str:slug>', AddToCartView.as_view(), name='add-to-cart'),
    path('delete-from-cart/<str:ct_model>/<str:slug>', DeleteFromCartView.as_view(), name='delete-from-cart'),
    path('change-qty/<str:ct_model>/<str:slug>', ChangeQTYView.as_view(), name='change-qty'),
    path('checkout/', CheckoutView.as_view(), name='checkout'),
    path('make-order/', MakeOrderView.as_view(), name='make-order')
]

shop/forms.py
from django import forms

from .models import Order



class OrderForm(forms.ModelForm):
    
    def __init__(self, *args, **kwargs):
        super(OrderForm, self).__init__(*args, **kwargs)
        self.fields['order_date'].label = 'Date of receipt'
    
    order_date = forms.DateField(widget=forms.TextInput(attrs={'type':'date'}))


    class Meta:
        model = Order
        fields = (
            'first_name', 'last_name', 'phone', 'address', 'buying_type', 'order_date', 'comment'
        )

shop/views.py
from django.shortcuts import render, redirect
from django.views.generic import DetailView, View
from django.contrib.contenttypes.models import ContentType
from django.contrib import messages
from django.db import transaction


from .models import Notebook, Smartphone, Category, LatestProducts, Customer, Cart, CartProduct
from .mixins import CategoryDetailMixin, CartMixin
from .forms import OrderForm
from .utils import recalc_cart



class BaseView(CartMixin, View):

    def get(self, request, *args, **kwargs):
        categories = Category.objects.get_categories_navbar()

        products = LatestProducts.objects.get_products_for_main_page(
            'notebook', 'smartphone', with_respect_to='notebook')

        context = {
            'categories': categories,
            'products': products,
            'cart': self.cart
        }
        return render(request, 'shop/main-shop-page.html', context)


class ProductDetailView(CategoryDetailMixin, CartMixin, DetailView):
    CT_MODEL_MODEL_CLASS = {
        'notebook': Notebook,
        'smartphone': Smartphone
    }

    def dispatch(self, request, *args, **kwargs):
        self.model = self.CT_MODEL_MODEL_CLASS[kwargs['ct_model']]
        self.queryset = self.model._base_manager.all()
        return super().dispatch(request, *args, **kwargs)

    context_object_name = 'product'
    template_name = 'shop/product_detail.html'
    slug_url_kwarg = 'slug'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['ct_model'] = self.model._meta.model_name
        context['cart'] = self.cart
        return context


class CategoryDetailView(CartMixin, CategoryDetailMixin, DetailView):
    model = Category
    queryset = Category.objects.all()
    context_object_name = 'category'
    template_name = 'shop/category_detail.html'
    slug_url_kwarg = 'slug'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['cart'] = self.cart
        return context



class AddToCartView(CartMixin, View):

    def get(self, request, *args, **kwargs):
        ct_model, product_slug = kwargs.get('ct_model'), kwargs.get('slug')
        content_type = ContentType.objects.get(model=ct_model)
        product = content_type.model_class().objects.get(slug=product_slug)
        cart_product, created = CartProduct.objects.get_or_create(
            user=self.cart.owner,
            cart=self.cart,
            content_type = content_type,
            object_id = product.id
        )
        if created:
            self.cart.products.add(cart_product)

        recalc_cart(self.cart)
        messages.add_message(request, messages.INFO, 'Product has been added')
        return redirect('shop:cart')


class DeleteFromCartView(CartMixin, View):
    def get(self, request, *args, **kwargs):
        ct_model, product_slug = kwargs.get('ct_model'), kwargs.get('slug')
        content_type = ContentType.objects.get(model=ct_model)
        product = content_type.model_class().objects.get(slug=product_slug)
        cart_product = CartProduct.objects.get(
            user=self.cart.owner,
            cart=self.cart,
            content_type=content_type,
            object_id=product.id
        )

        self.cart.products.remove(cart_product)
        cart_product.delete()
        recalc_cart(self.cart)
        messages.add_message(request, messages.INFO, 'Product has been removed')

        return redirect('shop:cart')

class ChangeQTYView(CartMixin, View):

    def post(self, request, *args, **kwargs):
        ct_model, product_slug = kwargs.get('ct_model'), kwargs.get('slug')
        content_type = ContentType.objects.get(model=ct_model)
        product = content_type.model_class().objects.get(slug=product_slug)
        cart_product = CartProduct.objects.get(
            user=self.cart.owner,
            cart=self.cart,
            content_type=content_type,
            object_id=product.id
        )
        qty = int(request.POST.get('qty'))
        cart_product.qty = qty
        cart_product.save()
        recalc_cart(self.cart)
        messages.add_message(request, messages.INFO, 'Quantity has been changed')

        return redirect('shop:cart')


class CartView(CartMixin, View):

    def get(self, request, *args, **kwargs):
        categories = Category.objects.get_categories_navbar()
        context = {
            'cart': self.cart,
            'categories': categories
        }
        return render(request, 'shop/cart.html', context)


class CheckoutView(CartMixin, View):

    def get(self, request, *args, **kwargs):
        categories = Category.objects.get_categories_navbar()
        form = OrderForm(request.POST or None)
        context = {
            'cart': self.cart,
            'categories': categories,
            'form': form
        }

        return render(request, 'shop/checkout.html', context)


class MakeOrderView(CartMixin, View):

    @transaction.atomic
    def post(self, request, *args, **kwargs):
        form = OrderForm(request.POST or None)
        customer = Customer.objects.get(user=request.user)
        if form.is_valid():
            data = form.cleaned_data
            new_order = form.save(commit=False)
            new_order.customer = customer

            new_order.first_name = data['first_name']
            new_order.last_name = data['last_name']
            new_order.phone = data['phone']
            new_order.address = data['address']
            new_order.buying_type = data['buying_type']
            new_order.order_date = data['order_date']
            new_order.comment =data['comment']
            new_order.save()
            self.cart.in_order = True
            self.cart.save()
            new_order.cart = self.cart
            new_order.save()
            customer.orders.add(new_order)
            messages.add_message(request, messages.INFO, 'Thank you for order.')
            return redirect('shop:shop_main')
        return redirect('shop:checkout')

templates/shop/add-product.html
{% extends 'index.html' %}
{% block content %}

<h1>Add product</h1>
<form action="." method="post", enctype="multipart/form-data">
    {% csrf_token %}
    {% for f in form %}
        <div>
            <label for="">{{f.label}}</label>
            {{ f }}
            {% if f.errors %}
                <ul>
                    {% for err in errors %}
                        <li style="color: red">
                            {{ err }}
                        </li>
                    {% endfor %}
                </ul>
            {% endif %}
        </div>
    {% endfor %}
    <button class="btn btn-info">Add product</button>
</form>

{% endblock %}

templates/shop/cart.html
{% extends 'shop/main-shop-page.html' %}
{% block content %}
<h3 class="text-center mt-5 mb-5">Your cart{%if not cart.products.count %} is empty{%endif%}</h3>

{% if messages %}
    {% for message in messages %}
      <div class="alert alert-success alert-dismissible fade show" role="alert">
        {{message}}
          <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
      </div>
    {% endfor %}
{% endif %}

{% if cart.products.count %}
  <table class="table table-hover">
  <thead>
    <tr>
      <th scope="col">Product name</th>
      <th scope="col">Image</th>
      <th scope="col">Price</th>
      <th scope="col">Amount</th>
      <th scope="col">Summary price</th>
      <th scope="col">Action</th>
    </tr>
  </thead>
  <tbody>
  {% for item in cart.products.all %}
    <tr>
      <th scope="row">{{item.content_object.product_name}}</th>
      <td class="w-25"><img class="img-fluid" src="{{item.content_object.image.url}}" alt=""></td>
      <td>{{item.content_object.price}}</td>
      <td>
        <form action="{% url 'shop:change-qty' ct_model=item.content_object.get_model_name slug=item.content_object.slug %}" method="POST">
          {%csrf_token%}
          <input type="number" class="form-control"  name="qty" style="width: 70px;" min="1" value="{{item.qty}}">
          <br>
          <input type="submit" class="btn btn-primary" value="Change quantity" >
        </form>
      </td>
      <td>{{item.final_price}} $</td>
      <td><a href="{% url 'shop:delete-from-cart' ct_model=item.content_object.get_model_name slug=item.content_object.slug %}">
        <button class="btn btn-danger">Delete from cart</button>
      </a></td>
    </tr>
    {% endfor %}
  <tr>
    <td colspan="2"></td>
    <td><strong>Summary</strong></td>
    <td>{{cart.total_products}}</td>
    <td>{{cart.final_price}} $</td>
    <td><a href="{%url 'shop:checkout'%}" class="btn btn-primary">Create order</a></td>
  </tr>
  </tbody>
</table>
{% endif %}

{% endblock %}

templates/shop/category_detail.html
{% extends 'shop/main-shop-page.html' %}
{% block content %}


<nav aria-label="breadcrumb">
  <ol class="breadcrumb">
    <li class="breadcrumb-item"><a href="{% url 'shop:shop_main'%}">Main</a></li>
    <li class="breadcrumb-item">{{category.name}}</li>
  </ol>
</nav>
<div class="row gx-4 gx-lg-5 row-cols-2 row-cols-md-3 row-cols-xl-4 justify-content-center">
    {% for product in category_products %}
    <div class="col mb-5">
        <div class="card h-100">
            <!-- Product image-->
            <img class="card-img-top" src="{{product.image.url}}" alt="..." />
            <!-- Product details-->
            <div class="card-body p-4">
                <div class="text-center">
                    <!-- Product name-->
                    <h5 class="fw-bolder">{{ product.product_name}}</h5>
                    <!-- Product price-->
                    {{product.price}} $
                    <br>
                    <a href="{% url 'shop:add-to-cart' ct_model=product.get_model_name slug=product.slug%}">
                                        <button class="btn btn-danger">Add to cart</button></a>
                </div>

            </div>
            <!-- Product actions-->
            <div class="card-footer p-4 pt-0 border-top-0 bg-transparent">
                <div class="text-center"><a class="btn btn-outline-dark mt-auto" href="{{ product.get_absolute_url }}">Detail</a></div>
            </div>
        </div>
    </div>
    {% endfor %}
</div>


{% endblock %}

templates/shop/checkout.html
{% extends 'shop/main-shop-page.html' %}
{% block content %}
{% load crispy_forms_tags %}

<h3 class="text-center mt-5 mb-5">Ordering</h3>

<table class="table table-hover">
  <thead>
    <tr>
      <th scope="col">Product name</th>
      <th scope="col">Image</th>
      <th scope="col">Price</th>
      <th scope="col">Amount</th>
      <th scope="col">Summary price</th>
    </tr>
  </thead>
  <tbody>
  {% for item in cart.products.all %}
    <tr>
      <th scope="row">{{item.content_object.product_name}}</th>
      <td class="w-25"><img class="img-fluid" src="{{item.content_object.image.url}}" alt=""></td>
      <td>{{item.content_object.price}}</td>
      <td>{{item.qty}}</td>
      <td>{{item.final_price}} $</td>

    </tr>
    {% endfor %}
  <tr>
    <td colspan="2"></td>
    <td><strong>Summary</strong></td>
    <td>{{cart.total_products}}</td>
    <td>{{cart.final_price}} $</td>
  </tr>
  </tbody>
</table>
<hr>
<h3 class="text-center mt-5 mb-5">Ordering form</h3>

<form action="{% url 'shop:make-order' %}" method="POST">
  {% csrf_token %}
  {{ form | crispy}}
  <input type="submit" class="btn btn-success btn-block md-3" value="Checkout">
</form>


{% endblock %}

templates/shop/main-shop-page.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="utf-8" />
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />
        <meta name="description" content="" />
        <meta name="author" content="" />
        <title>Shop Homepage - Start Bootstrap Template</title>
        <!-- Favicon-->
        <link rel="icon" type="image/x-icon" href="assets/favicon.ico" />
        <!-- Sidebar CS -->
        <!-- Bootstrap icons-->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
        <!-- Core theme CSS (includes Bootstrap)-->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-F3w7mX95PdgyTmZZMECAngseQB83DfGTowi0iMjiWaeVhAn4FJkqJByhZMI3AhiU" crossorigin="anonymous">    <body>
        <!-- Navigation-->
        <nav class="navbar navbar-expand-lg navbar-light bg-light">
            <div class="container px-4 px-lg-5">
                <a class="navbar-brand" href="#!">Start Bootstrap</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation"><span class="navbar-toggler-icon"></span></button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-2 mb-lg-0 ms-lg-4">
                        <li class="nav-item"><a class="nav-link active" aria-current="page" href="{% url 'shop:shop_main' %}">Home</a></li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" id="navbarDropdown" href="#" role="button" data-bs-toggle="dropdown" aria-expanded="false">Categories</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">

                                {% for category in categories %}
                                    <li><a class="dropdown-item" href="{{category.url}}">{{category.name}} ({{category.count}}) </a></li>
                                {% endfor %}

                            </ul>
                        </li>
<!--                        <li class="nav-item"><a class="nav-link" href="{% url 'shop:cart' %} ">Cart <span class="badge badge-pill badge-danger">{{cart.products.count}}</span></a></li>-->

                    </ul>
                    <div class="d-flex">
                        <a class="btn btn-outline-dark bi-cart-fill me-1" href="{% url 'shop:cart' %} ">Cart <span class="badge badge-pill badge-danger">{{cart.products.count}}</span></a>
                    </div>
<!--                    <form class="d-flex">-->
<!--                        <button class="btn btn-outline-dark" type="submit">-->
<!--                            <i class="bi-cart-fill me-1"></i>-->
<!--                            Cart-->
<!--                            <span class="badge bg-dark text-white ms-1 rounded-pill">0</span>-->
<!--                        </button>-->
<!--                    </form>-->
                </div>
            </div>
        </nav>
        <!-- Header-->
        <header class="bg-dark py-5">
            <div class="container px-4 px-lg-5 my-5">
                <div class="text-center text-white">
                    <h1 class="display-4 fw-bolder">Shop in style</h1>
                    <p class="lead fw-normal text-white-50 mb-0">With this shop homepage template</p>
                </div>
            </div>
        </header>
        <!-- Section-->

        <section class="py-5">
            <div class="container px-4 px-lg-5 mt-5">
                {% block content %}
                {% if messages %}
                    {% for message in messages %}
                      <div class="alert alert-success alert-dismissible fade show" role="alert">
                        {{message}}
                          <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                      </div>
                    {% endfor %}
                {% endif %}

                <div class="row gx-4 gx-lg-5 row-cols-2 row-cols-md-3 row-cols-xl-4 justify-content-center">
                    {% for product in products %}

                    <div class="col mb-5">
                        <div class="card h-100">
                            <!-- Product image-->
                            <img class="card-img-top" src="{{product.image.url}}" alt="..." />
                            <!-- Product details-->
                            <div class="card-body p-4">
                                <div class="text-center">
                                    <!-- Product name-->
                                    <h5 class="fw-bolder">{{ product.product_name}}</h5>
                                    <!-- Product price-->
                                    {{product.price}} $
                                    <br>
                                    <a href="{% url 'shop:add-to-cart' ct_model=product.get_model_name slug=product.slug%}">
                                        <button class="btn btn-danger">Add to cart</button>
                                    </a>
                                </div>
                            </div>
                            <!-- Product actions-->
                            <div class="card-footer p-4 pt-0 border-top-0 bg-transparent">
                                <div class="text-center"><a class="btn btn-outline-dark mt-auto" href="{{ product.get_absolute_url }}">Detail</a></div>
                            </div>
                        </div>
                    </div>

                    {% endfor %}
                </div>
                {% endblock %}
            </div>


        </section>
        <!-- Footer-->
        <footer class="py-5 bg-dark">
            <div class="container"><p class="m-0 text-center text-white">Copyright &copy; Your Website 2021</p></div>
        </footer>
        <!-- Bootstrap core JS-->
            <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
            <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.9.3/dist/umd/popper.min.js" integrity="sha384-W8fXfP3gkOKtndU4JGtKDvXbO53Wy8SZCQHczT5FMiiqmQfUpWbYdTil/SxwZgAN" crossorigin="anonymous"></script>
            <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.min.js" integrity="sha384-skAcpIdS7UcVUC05LJ9Dxay8AXcDYfBJqt1CJ85S/CFujBsIzCIv+l9liuYLaMQ/" crossorigin="anonymous"></script>
            <!-- Core theme JS-->
<!--            <script src="js/scripts.js"></script>-->
    </body>
</html>

templates/shop/notebook_specification.html
    <table class="table">
          <tbody>
            <tr>
              <td>Diagonal</td>
              <td>{{product.diagonal}}</td>
            </tr>
            <tr>
                <td>Display</td>
                <td>{{product.display_type}}</td>
            </tr>
            <tr>
                <td>Processor frequency</td>
                <td>{{product.processor_freq}}</td>
            </tr>
            <tr>
                <td>RAM</td>
                <td>{{product.ram}}</td>
            </tr>
            <tr>
                <td>Video</td>
                <td>{{product.video}}</td>
            </tr>

          </tbody>
    </table>

templates/shop/product_detail.html
{% extends 'shop/main-shop-page.html' %}
{% load specifications %}
{% block content %}

<nav aria-label="breadcrumb">
  <ol class="breadcrumb">
    <li class="breadcrumb-item"><a href="{% url 'shop:shop_main'%}}">Main</a></li>
    <li class="breadcrumb-item"><a href="#">{{product.category.name}}</a></li>
    <li class="breadcrumb-item active" aria-current="page">{{product.product_name}}</li>
  </ol>
</nav>

<div class="row">
    <div class="col-md-4">
        <img src="{{ product.image.url }}" class="img-fluid">
    </div>

    <div class="col-md-8">
        <h3>{{product.product_name}}</h3>
        <p>Price : {{product.price}}</p>
        <a href="{% url 'shop:add-to-cart' ct_model=ct_model slug=product.slug %}" class="btn btn-danger">Add to cart</a>
    </div>
    <p class="mt-4">Characteristic :</p>
        {{product|product_spec}}



<!--    {% if product.category.slug == 'notebooks' %}-->
<!--        {% include 'shop/notebook_specification.html' %}-->
<!--    {% else %}-->
<!--        {% include 'shop/smartphone_specification.html' %}-->
<!--    {%endif%}-->

</div>

{% endblock %}

templates/shop/smartphone_specification.html
    <table class="table">
          <tbody>
            <tr>
              <td>Diagonal</td>
              <td>{{product.diagonal}}</td>
            </tr>
            <tr>
                <td>Display</td>
                <td>{{product.display_type}}</td>
            </tr>
            <tr>
                <td>Resolution</td>
                <td>{{product.resolution}}</td>
            </tr>
            <tr>
                <td>RAM</td>
                <td>{{product.ram}}</td>
            </tr>
            <tr>
                <td>Accum volume</td>
                <td>{{product.accum_volume}}</td>
            </tr>
            <tr>
                <td>SD </td>
                <td>{{product.sd}}</td>
            </tr>
            <tr>
                <td>Camera</td>
                <td>{{product.camera_mp}}</td>
            </tr>

          </tbody>
    </table>